api/urls.py
# Copyright (C) 2020 by Animath
# SPDX-License-Identifier: GPL-3.0-or-later

from django.conf import settings
from django.urls import include, path
from rest_framework import routers

from .viewsets import UserViewSet

# Routers provide an easy way of automatically determining the URL conf.
# Register each app API router and user viewset
router = routers.DefaultRouter()
router.register('user', UserViewSet)

if "logs" in settings.INSTALLED_APPS:
    from logs.api.urls import register_logs_urls
    register_logs_urls(router, "logs")

if "participation" in settings.INSTALLED_APPS:
    from participation.api.urls import register_participation_urls
    register_participation_urls(router, "participation")

if "registration" in settings.INSTALLED_APPS:
    from registration.api.urls import register_registration_urls
    register_registration_urls(router, "registration")

app_name = 'api'

# Wire up our API using automatic URL routing.
# Additionally, we include login URLs for the browsable API.
urlpatterns = [
    path('', include(router.urls)),
    path('api-auth/', include('rest_framework.urls', namespace='rest_framework')),
]

chat/urls.py
# Copyright (C) 2024 by Animath
# SPDX-License-Identifier: GPL-3.0-or-later

from django.contrib.auth.views import LoginView, LogoutView
from django.urls import path
from django.utils.translation import gettext_lazy as _
from tfjm.views import LoginRequiredTemplateView

app_name = 'chat'

urlpatterns = [
    path('', LoginRequiredTemplateView.as_view(template_name="chat/chat.html",
                                               extra_context={'title': _("Chat")}), name='chat'),
    path('fullscreen/', LoginRequiredTemplateView.as_view(template_name="chat/fullscreen.html", login_url='chat:login'),
         name='fullscreen'),
    path('login/', LoginView.as_view(template_name="chat/login.html"), name='login'),
    path('logout/', LogoutView.as_view(next_page='chat:fullscreen'), name='logout'),
]

draw/urls.py
# Copyright (C) 2023 by Animath
# SPDX-License-Identifier: GPL-3.0-or-later

from django.urls import path

from .views import DisplayView


app_name = "draw"

urlpatterns = [
    path('', DisplayView.as_view(), name='index'),
]

participation/urls.py
# Copyright (C) 2020 by Animath
# SPDX-License-Identifier: GPL-3.0-or-later

from django.urls import path

from .views import CreateTeamView, FinalNotationSheetTemplateView, GSheetNotificationsView, JoinTeamView, \
    MyParticipationDetailView, MyTeamDetailView, NotationSheetsArchiveView, NoteUpdateView, ParticipationDetailView, \
    PassageDetailView, PassageUpdateView, PoolCreateView, PoolDetailView, PoolJuryView, PoolNotesTemplateView, \
    PoolPresideJuryView, PoolRemoveJuryView, PoolUpdateView, PoolUploadNotesView, \
    ScaleNotationSheetTemplateView, SelectTeamFinalView, \
    SolutionsDownloadView, SolutionUploadView, \
    TeamAuthorizationsView, TeamDetailView, TeamLeaveView, TeamListView, TeamUpdateView, \
    TeamUploadMotivationLetterView, TournamentCreateView, TournamentDetailView, TournamentExportCSVView, \
    TournamentHarmonizeNoteView, TournamentHarmonizeView, TournamentListView, TournamentPaymentsView, \
    TournamentPublishNotesView, TournamentUpdateView, WrittenReviewUploadView


app_name = "participation"

urlpatterns = [
    path("create_team/", CreateTeamView.as_view(), name="create_team"),
    path("join_team/", JoinTeamView.as_view(), name="join_team"),
    path("teams/", TeamListView.as_view(), name="team_list"),
    path("team/", MyTeamDetailView.as_view(), name="my_team_detail"),
    path("team/<int:pk>/", TeamDetailView.as_view(), name="team_detail"),
    path("team/<int:pk>/update/", TeamUpdateView.as_view(), name="update_team"),
    path("team/<int:pk>/upload-motivation-letter/", TeamUploadMotivationLetterView.as_view(),
         name="upload_team_motivation_letter"),
    path("team/<int:team_id>/authorizations/", TeamAuthorizationsView.as_view(), name="team_authorizations"),
    path("team/leave/", TeamLeaveView.as_view(), name="team_leave"),
    path("detail/", MyParticipationDetailView.as_view(), name="my_participation_detail"),
    path("detail/<int:pk>/", ParticipationDetailView.as_view(), name="participation_detail"),
    path("detail/<int:pk>/solution/", SolutionUploadView.as_view(), name="upload_solution"),
    path("detail/<int:team_id>/solutions/", SolutionsDownloadView.as_view(), name="participation_solutions"),
    path("tournament/", TournamentListView.as_view(), name="tournament_list"),
    path("tournament/create/", TournamentCreateView.as_view(), name="tournament_create"),
    path("tournament/<int:pk>/", TournamentDetailView.as_view(), name="tournament_detail"),
    path("tournament/<int:pk>/update/", TournamentUpdateView.as_view(), name="tournament_update"),
    path("tournament/<int:pk>/payments/", TournamentPaymentsView.as_view(), name="tournament_payments"),
    path("tournament/<int:pk>/csv/", TournamentExportCSVView.as_view(), name="tournament_csv"),
    path("tournament/<int:tournament_id>/authorizations/", TeamAuthorizationsView.as_view(),
         name="tournament_authorizations"),
    path("tournament/<int:tournament_id>/solutions/", SolutionsDownloadView.as_view(),
         name="tournament_solutions"),
    path("tournament/<int:tournament_id>/written_reviews/", SolutionsDownloadView.as_view(),
         name="tournament_written_reviews"),
    path("tournament/<int:tournament_id>/notation/sheets/", NotationSheetsArchiveView.as_view(),
         name="tournament_notation_sheets"),
    path("tournament/<int:pk>/notation/notifications/", GSheetNotificationsView.as_view(),
         name="tournament_gsheet_notifications"),
    path("tournament/<int:pk>/publish-notes/<int:round>/", TournamentPublishNotesView.as_view(),
         name="tournament_publish_notes"),
    path("tournament/<int:pk>/harmonize/<int:round>/", TournamentHarmonizeView.as_view(),
         name="tournament_harmonize"),
    path("tournament/<int:pk>/harmonize/<int:round>/<str:action>/<str:trigram>/", TournamentHarmonizeNoteView.as_view(),
         name="tournament_harmonize_note"),
    path("tournament/<int:pk>/select-final/<int:participation_id>/", SelectTeamFinalView.as_view(),
         name="select_team_final"),
    path("pools/create/", PoolCreateView.as_view(), name="pool_create"),
    path("pools/<int:pk>/", PoolDetailView.as_view(), name="pool_detail"),
    path("pools/<int:pk>/update/", PoolUpdateView.as_view(), name="pool_update"),
    path("pools/<int:pool_id>/solutions/", SolutionsDownloadView.as_view(), name="pool_download_solutions"),
    path("pools/<int:pool_id>/written_reviews/", SolutionsDownloadView.as_view(), name="pool_download_written_reviews"),
    path("pools/<int:pk>/notation/scale/", ScaleNotationSheetTemplateView.as_view(), name="pool_scale_note_sheet"),
    path("pools/<int:pk>/notation/final/", FinalNotationSheetTemplateView.as_view(), name="pool_final_note_sheet"),
    path("pools/<int:pool_id>/notation/sheets/", NotationSheetsArchiveView.as_view(), name="pool_notation_sheets"),
    path("pools/<int:pk>/jury/", PoolJuryView.as_view(), name="pool_jury"),
    path("pools/<int:pk>/jury/remove/<int:jury_id>/", PoolRemoveJuryView.as_view(), name="pool_remove_jury"),
    path("pools/<int:pk>/jury/preside/<int:jury_id>/", PoolPresideJuryView.as_view(), name="pool_preside"),
    path("pools/<int:pk>/upload-notes/", PoolUploadNotesView.as_view(), name="pool_upload_notes"),
    path("pools/<int:pk>/upload-notes/template/", PoolNotesTemplateView.as_view(), name="pool_notes_template"),
    path("pools/passages/<int:pk>/", PassageDetailView.as_view(), name="passage_detail"),
    path("pools/passages/<int:pk>/update/", PassageUpdateView.as_view(), name="passage_update"),
    path("pools/passages/<int:pk>/written_review/", WrittenReviewUploadView.as_view(), name="upload_written_review"),
    path("pools/passages/notes/<int:pk>/", NoteUpdateView.as_view(), name="update_notes"),
]

registration/urls.py
# Copyright (C) 2020 by Animath
# SPDX-License-Identifier: GPL-3.0-or-later

from django.urls import path

from .views import AddOrganizerView, AdultPhotoAuthorizationTemplateView, ChildPhotoAuthorizationTemplateView, \
    InstructionsTemplateView, MyAccountDetailView, ParentalAuthorizationTemplateView, \
    PaymentHelloAssoReturnView, PaymentRedirectHelloAssoView, PaymentUpdateGroupView, PaymentUpdateView, \
    ResetAdminView, SignupView, UserDetailView, UserImpersonateView, UserListView, UserResendValidationEmailView, \
    UserUpdateView, UserUploadHealthSheetView, UserUploadParentalAuthorizationView, UserUploadPhotoAuthorizationView, \
    UserUploadVaccineSheetView, UserValidateView, UserValidationEmailSentView

app_name = "registration"

urlpatterns = [
    path("signup/", SignupView.as_view(), name="signup"),
    path("add-organizer/", AddOrganizerView.as_view(), name="add_organizer"),
    path('validate_email/sent/', UserValidationEmailSentView.as_view(), name='email_validation_sent'),
    path('validate_email/resend/<int:pk>/', UserResendValidationEmailView.as_view(),
         name='email_validation_resend'),
    path('validate_email/<uidb64>/<token>/', UserValidateView.as_view(), name='email_validation'),
    path("user/", MyAccountDetailView.as_view(), name="my_account_detail"),
    path("user/<int:pk>/", UserDetailView.as_view(), name="user_detail"),
    path("user/<int:pk>/update/", UserUpdateView.as_view(), name="update_user"),
    path("user/<int:pk>/upload-photo-authorization/", UserUploadPhotoAuthorizationView.as_view(),
         name="upload_user_photo_authorization"),
    path("user/<int:pk>/upload-photo-authorization/final/", UserUploadPhotoAuthorizationView.as_view(),
         name="upload_user_photo_authorization_final"),
    path("parental-authorization-template/", ParentalAuthorizationTemplateView.as_view(),
         name="parental_authorization_template"),
    path("photo-authorization-template/adult/", AdultPhotoAuthorizationTemplateView.as_view(),
         name="photo_authorization_adult_template"),
    path("photo-authorization-template/child/", ChildPhotoAuthorizationTemplateView.as_view(),
         name="photo_authorization_child_template"),
    path("instructions-template/", InstructionsTemplateView.as_view(), name="instructions_template"),
    path("user/<int:pk>/upload-health-sheet/", UserUploadHealthSheetView.as_view(),
         name="upload_user_health_sheet"),
    path("user/<int:pk>/upload-vaccine-sheet/", UserUploadVaccineSheetView.as_view(),
         name="upload_user_vaccine_sheet"),
    path("user/<int:pk>/upload-parental-authorization/", UserUploadParentalAuthorizationView.as_view(),
         name="upload_user_parental_authorization"),
    path("user/<int:pk>/upload-parental-authorization/final/", UserUploadParentalAuthorizationView.as_view(),
         name="upload_user_parental_authorization_final"),
    path("update-payment/<int:pk>/", PaymentUpdateView.as_view(), name="update_payment"),
    path("update-payment/<int:pk>/toggle-group-mode/", PaymentUpdateGroupView.as_view(),
         name="update_payment_group_mode"),
    path("update-payment/<int:pk>/hello-asso/", PaymentRedirectHelloAssoView.as_view(), name="payment_hello_asso"),
    path("update-payment/<int:pk>/hello-asso/return/", PaymentHelloAssoReturnView.as_view(),
         name="payment_hello_asso_return"),
    path("user/<int:pk>/impersonate/", UserImpersonateView.as_view(), name="user_impersonate"),
    path("user/list/", UserListView.as_view(), name="user_list"),
    path("reset-admin/", ResetAdminView.as_view(), name="reset_admin"),
]

tfjm/urls.py
# Copyright (C) 2020 by Animath
# SPDX-License-Identifier: GPL-3.0-or-later

"""tfjm URL Configuration

The `urlpatterns` list routes URLs to views. For more information please see:
    https://docs.djangoproject.com/en/3.0/topics/http/urls/
Examples:
Function views
    1. Add an import:  from my_app import views
    2. Add a URL to urlpatterns:  path('', views.home, name='home')
Class-based views
    1. Add an import:  from other_app.views import Home
    2. Add a URL to urlpatterns:  path('', Home.as_view(), name='home')
Including another URLconf
    1. Import the include() function: from django.urls import include, path
    2. Add a URL to urlpatterns:  path('blog/', include('blog.urls'))
"""
from django.conf import settings
from django.contrib import admin
from django.urls import include, path
from django.utils.translation import gettext_lazy as _
from django.views.defaults import bad_request, page_not_found, permission_denied, server_error
from django.views.generic import TemplateView
from participation.views import MotivationLetterView
from registration.views import HealthSheetView, ParentalAuthorizationView, PhotoAuthorizationView, \
    ReceiptView, SolutionView, VaccineSheetView, WrittenReviewView

from .views import AdminSearchView

urlpatterns = [
    path('', TemplateView.as_view(template_name=f"index_{settings.TFJM_APP.lower()}.html",
                                  extra_context={'title': _("Home")}),
         name='index'),
    path('about/', TemplateView.as_view(template_name="about.html"), name='about'),
    path('i18n/', include('django.conf.urls.i18n')),
    path('admin/doc/', include('django.contrib.admindocs.urls')),
    path('admin/', admin.site.urls, name="admin"),
    path('accounts/', include('django.contrib.auth.urls')),
    path('search/', AdminSearchView.as_view(), name="haystack_search"),

    path('api/', include('api.urls')),
    path('chat/', include('chat.urls')),
    path('draw/', include('draw.urls')),
    path('participation/', include('participation.urls')),
    path('registration/', include('registration.urls')),

    path('media/authorization/photo/<str:filename>/', PhotoAuthorizationView.as_view(),
         name='photo_authorization'),
    path('media/authorization/health/<str:filename>/', HealthSheetView.as_view(),
         name='health_sheet'),
    path('media/authorization/vaccine/<str:filename>/', VaccineSheetView.as_view(),
         name='vaccine_sheet'),
    path('media/authorization/parental/<str:filename>/', ParentalAuthorizationView.as_view(),
         name='parental_authorization'),
    path('media/authorization/receipt/<str:filename>/', ReceiptView.as_view(),
         name='receipt'),
    path('media/authorization/motivation_letters/<str:filename>/', MotivationLetterView.as_view(),
         name='motivation_letter'),

    path('media/solutions/<str:filename>/', SolutionView.as_view(),
         name='solution'),
    path('media/reviews/<str:filename>/', WrittenReviewView.as_view(),
         name='reviews'),
]

if settings.DEBUG:
    # Serve static files in DEBUG mode
    import django.contrib.staticfiles.urls
    urlpatterns += django.contrib.staticfiles.urls.urlpatterns

handler400 = bad_request
handler403 = permission_denied
handler404 = page_not_found
handler500 = server_error

tfjm/views.py
# Copyright (C) 2020 by Animath
# SPDX-License-Identifier: GPL-3.0-or-later

from django.contrib.auth.mixins import LoginRequiredMixin
from django.contrib.auth.models import User
from django.views.generic import TemplateView
from haystack.generic_views import SearchView


class AdminMixin(LoginRequiredMixin):
    def dispatch(self, request, *args, **kwargs):
        if request.user.is_authenticated and not request.user.registration.is_admin:
            self.handle_no_permission()
        return super().dispatch(request, *args, **kwargs)


class VolunteerMixin(LoginRequiredMixin):
    def dispatch(self, request, *args, **kwargs):
        if request.user.is_authenticated and not request.user.registration.is_volunteer:
            self.handle_no_permission()
        return super().dispatch(request, *args, **kwargs)


class UserMixin(LoginRequiredMixin):
    def dispatch(self, request, *args, **kwargs):
        user = request.user
        if user.is_authenticated and not user.registration.is_admin and user.pk != kwargs["pk"]:
            self.handle_no_permission()
        return super().dispatch(request, *args, **kwargs)


class UserRegistrationMixin(LoginRequiredMixin):
    def dispatch(self, request, *args, **kwargs):
        user = request.user
        user_object = User.objects.get(registration__pk=kwargs["pk"])
        if user.is_authenticated and not user.registration.is_admin and user.registration.pk != kwargs["pk"] and \
                not (user.registration.is_volunteer and user_object.registration.team is not None
                     and user_object.registration.team.participation.tournament
                     in user.registration.organized_tournaments.all()):
            self.handle_no_permission()
        return super().dispatch(request, *args, **kwargs)


class LoginRequiredTemplateView(LoginRequiredMixin, TemplateView):
    pass


class AdminSearchView(AdminMixin, SearchView):
    pass

tfjm/templates/amount_input.html
<div class="input-group">
    <input class="form-control mx-auto d-block" type="number" min="0" step="0.01"
           {% if widget.value != None and widget.value != "" %}value="{{ widget.value }}"{% endif %}
           name="{{ widget.name }}"
            {% for name, value in widget.attrs.items %}
                {% ifnotequal value False %}{{ name }}{% ifnotequal value True %}="{{ value|stringformat:'s' }}"{% endifnotequal %}{% endifnotequal %}
            {% endfor %}>
    <div class="input-group-append">
        <span class="input-group-text">€</span>
    </div>
</div>

tfjm/templates/autocomplete_model.html
<input type="hidden" name="{{ widget.name }}" {% if widget.attrs.model_pk %}value="{{ widget.attrs.model_pk }}"{% endif %} id="{{ widget.attrs.id }}_pk">
<input type="text"
   {% if widget.value != None and widget.value != "" %}value="{{ widget.value }}"{% endif %}
   name="{{ widget.name }}_name" autocomplete="off"
    {% for name, value in widget.attrs.items %}
        {% ifnotequal value False %}{{ name }}{% ifnotequal value True %}="{{ value|stringformat:'s' }}"{% endifnotequal %}{% endifnotequal %}
    {% endfor %}>
<ul class="list-group list-group-flush" id="{{ widget.attrs.id }}_list">
</ul>

tfjm/templates/empty.html
{% block content %}{% endblock content %}

tfjm/templates/index_eteam.html
{% extends "base.html" %}

{% load i18n %}

{% block content-title %}{% endblock %}

{% block content %}
    <div class="jumbotron p-5">
        <div class="row text-center">
            <h1 class="display-4">
                {% trans "Welcome onto the registration site of the" %}
                <a href="https://eteam.tfjm.org/" target="_blank">ETEAM</a> !
            </h1>
        </div>
    </div>

    <div class="row p-5">
        <div class="col-sm">
            <h3>
                {% trans "You want to participate to the ETEAM ?" %}
                <br/>
                {% trans "Your team is selected and already complete?" %}
            </h3>
        </div>
        <div class="col-sm text-sm-end">
            <div class="btn-group-vertical">
                <a class="btn btn-primary btn-lg" href="{% url "registration:signup" %}" role="button">{% trans "Register now!" %}</a>
                <a class="btn btn-light text-dark btn-lg" href="{% url "login" %}" role="button">{% trans "I already have an account" %}</a>
            </div>
        </div>
    </div>

    <div class="jumbotron p-5 border rounded-5">
        <h5 class="display-4">{% trans "How does it work?" %}</h5>
        <p>
            {% url "registration:signup" as signup_url %}
            {% blocktrans trimmed %}
                To participate to the ETEAM, you must be selected by your national organization.
                If so, you just need to create an account on the <strong><a href="{{ signup_url }}">Registration</a></strong> page.
                You will then have to confirm your email address.
            {% endblocktrans %}
        </p>

        <p class="text-justify">
            {% url "login" as login_url %}
            {% blocktrans trimmed %}
                You can access your account via the <strong><a href="{{ login_url }}">Login</a></strong> page.
                Once logged in, you will be able to create a team or join one already created by one of your comrades
                via an access code that will have been transmitted to you. You will then be invited to submit a right to image authorization,
                essential for the smooth running of the ETEAM. Once your team has at least 4 participants (maximum 6)
                and a supervisor, you can request to validate your team to be able to work on the problems of your choice.
            {% endblocktrans %}
        </p>

        <h2>{% trans "I have a question" %}</h2>

        <p class="text-justify">
            {% blocktrans trimmed %}
                Do not hesitate to consult the <a href="/doc/" target="_blank">documentation</a> of the site, to check if
                the answer is not already there. Also refer of course to the
                <a href="https://eteam.tfjm.org/rules/" target="_blank">ETEAM rules</a>.
                For any other question, do not hesitate to contact us by email at the address
                <a href="mailto:eteam_moc@proton.me ">
                    eteam_moc@proton.me
                </a>.
            {% endblocktrans %}
        </p>
    </div>
{% endblock %}

tfjm/templates/messages.html
<div id="messages">
    {% for message in messages %}
        <div class="alert alert-{{ message.tags }} alert-dismissible fade show" role="alert">
            <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
            {{ message | safe }}
        </div>
    {% endfor %}
</div>

tfjm/templates/navbar.html
{% load i18n static %}

<nav class="navbar navbar-expand-lg fixed-navbar shadow-sm">
    <div class="container-fluid">
    <a class="navbar-brand" href="{{ TFJM.HOME_PAGE_LINK }}">
        <img src="{% static TFJM.LOGO_PATH %}" style="height: 2em;" alt="Logo {{ TFJM.APP_NAME }}" id="navbar-logo">
    </a>
    <button class="navbar-toggler" type="button" data-bs-toggle="collapse"
            data-bs-target="#navbarNavDropdown"
            aria-controls="navbarNavDropdown" aria-expanded="false"
            aria-label="Toggle navigation">
        <span class="navbar-toggler-icon"></span>
    </button>
    <div id="navbarNavDropdown" class="collapse navbar-collapse">
        <ul class="navbar-nav">
            <li class="nav-item active">
                <a href="{% url "index" %}" class="nav-link"><i class="fas fa-home"></i> {% trans "Home" %}</a>
            </li>
            <li class="nav-item active">
                {% if TFJM.SINGLE_TOURNAMENT %}
                    <a href="{% url 'participation:tournament_detail' pk=TFJM_TOURNAMENT.pk %}" class="nav-link">
                        <i class="fas fa-calendar-day"></i> {% trans "Tournament" %}
                    </a>
                {% else %}
                    <a href="#" class="nav-link" data-bs-toggle="modal" data-bs-target="#tournamentListModal">
                        <i class="fas fa-calendar-day"></i> {% trans "Tournaments" %}
                    </a>
                {% endif %}
            </li>
            {% if user.is_authenticated and user.registration.is_admin %}
                <li class="nav-item active">
                    <a href="{% url "registration:user_list" %}" class="nav-link"><i class="fas fa-user"></i> {% trans "Users" %}</a>
                </li>
                <li class="nav-item active">
                    <a href="{% url "participation:team_list" %}" class="nav-link"><i class="fas fa-users"></i> {% trans "Teams" %}</a>
                </li>
            {% elif user.is_authenticated and user.registration.participates %}
                {% if not user.registration.team %}
                    <li class="nav-item active">
                        <a href="#" class="nav-link" data-bs-toggle="modal" data-bs-target="#createTeamModal">
                            <i class="fas fa-users"></i> {% trans "Create team" %}
                        </a>
                    </li>
                    <li class="nav-item active">
                        <a href="#" class="nav-link" data-bs-toggle="modal" data-bs-target="#joinTeamModal">
                            <i class="fas fa-users"></i> {% trans "Join team" %}
                        </a>
                    </li>
                {% else %}
                    <li class="nav-item active">
                        <a href="{% url "participation:my_team_detail" %}" class="nav-link">
                            <i class="fas fa-users"></i> {% trans "My team" %}
                        </a>
                    </li>
                    <li class="nav-item active">
                        <a href="{% url "participation:my_participation_detail" %}" class="nav-link">
                            <i class="fas fa-file-pdf"></i> {% trans "My participation" %}
                        </a>
                    </li>
                {% endif %}
            {% endif %}
            {% if user.is_authenticated %}
                {% if user.registration.is_volunteer or user.registration.team %}
                    <li class="nav-item active">
                        <a class="nav-link" href="{% url 'draw:index' %}">
                            <i class="fas fa-archive"></i> {% trans "Draw" %}
                        </a>
                    </li>
                {% endif %}
                <li class="nav-item active">
                    <a class="nav-link" href="{% url "chat:chat" %}">
                        <i class="fas fa-comments"></i> {% trans "Chat" %}
                    </a>
                </li>
            {% endif %}
            {% if user.registration.is_admin %}
                <li class="nav-item active">
                    <a class="nav-link" href="{% url "admin:index" %}"><i class="fas fa-cog"></i> {% trans "Administration" %}</a>
                </li>
            {% endif %}
        </ul>
        <ul class="navbar-nav ms-auto">
            {% if user.registration.is_admin %}
                <form class="navbar-form d-flex" role="search" onsubmit="event.preventDefault()">
                    <div class="input-group">
                        <input type="text" class="form-control" placeholder="{% trans "Search…" %}" name="q" id="search-term" value="{{ request.GET.q }}">
                        <div class="input-group-btn">
                            <button class="btn btn-default" data-bs-toggle="modal" data-bs-target="#searchModal"><i class="fa fa-search text-body"></i></button>
                        </div>
                    </div>
                </form>
            {% endif %}
            {% if "_fake_user_id" in request.session %}
                <li class="nav-item active">
                    <a class="nav-link" href="{% url "registration:reset_admin" %}?path={{ request.path }}"><i class="fas fa-tools"></i> {% trans "Return to admin view" %}</a>
                </li>
            {% endif %}
            {% if not user.is_authenticated %}
                {% now "c" as now %}
                {% if TFJM.REGISTRATION_DATES.open.isoformat <= now and now <= TFJM.REGISTRATION_DATES.close.isoformat %}
                    <li class="nav-item active">
                        <a class="nav-link" href="{% url "registration:signup" %}"><i class="fas fa-user-plus"></i> {% trans "Register" %}</a>
                    </li>
                {% endif %}
                <li class="nav-item active">
                    <a class="nav-link" href="#" data-bs-toggle="modal" data-bs-target="#loginModal">
                        <i class="fas fa-sign-in-alt"></i> {% trans "Log in" %}
                    </a>
                </li>
            {% else %}
                <li class="nav-item dropdown">
                    <a class="nav-link dropdown-toggle" href="#" id="navbarDropdownMenuLink"
                       data-bs-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                        <i class="fas fa-user"></i> {{ user.first_name }} {{ user.last_name }}
                    </a>
                    <ul class="dropdown-menu dropdown-menu-end" aria-labelledby="navbarDropdownMenuLink">
                        <li>
                            <a class="dropdown-item" href="{% url "registration:my_account_detail" %}">
                                <i class="fas fa-user"></i> {% trans "My account" %}
                            </a>
                        </li>
                        <li>
                            <form action="{% url 'logout' %}" method="post">
                                {% csrf_token %}
                                <button class="dropdown-item">
                                    <i class="fas fa-sign-out-alt"></i> {% trans "Log out" %}
                                </button>
                            </form>
                        </li>
                    </ul>
                </li>
            {% endif %}
        </ul>
    </div>
    </div>
</nav>